import math

def load(list):
    print "Loading AI bindings"

    # binding format:
    # ( 'name of robot from .bot file', 'name of AI from script class',
    #       {'optional constructor parameter':value, 'another':value} )

    # constructor parameters:
    # nose - "front" of bot in radians (default 0)
    # invertible - can function upside-down (default False)
    # topspeed - speed in meters/second AI will attempt not to exceed (default 4.0)
    # throttle - maximum analog value AI will attempt not to exceed (default 100)
    # turnspeed - turning in radians/second AI will attempt not to exceed (default 2.5)
    # turn - maximum analog value AI will attempt not to exceed (default 60)
    # radius - bot radius to use for checking for hazards and walls (default 1.0)

    # 0 - Robot Wars Legends "We won quite a few times, and we'll happily beat up your bot in a fight!"
    list.append(("Zero","Flipper",{'nose':math.pi*2,'radius':0.1,'topspeed':100,'throttle':100,'turn':30,'turnspeed':5,'weapons':(8,9)}))
    list.append(("Code Red","Poker",{'nose':math.pi*2,'radius':0.1,'topspeed':100,'throttle':130,'turn':60,'turnspeed':5,'weapons':(13,14,16,17,18)}))
    list.append(("Chomp II","Flipper",{'nose':math.pi*2,'range':99,'radius':0.1,'topspeed':100,'throttle':130,'turn':60,'turnspeed':5,'weapons':(18,19)}))
    list.append(("Wedge of Doom","Omni",{'nose':math.pi,'tactic':"Charge",'ThresholdSpeed':0.02,'reload':16,'radius':1,'topspeed':100,'throttle':100,'turn':50,'turnspeed':2,'weapons':(13,)}))
    list.append(("T-Minus","Flipper2",{'nose':math.pi,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':1.5,'weapons':(16,)}))
    list.append(("Techno Destructo","Flipper2",{'nose':math.pi,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':2,'weapons':(18,)}))

    # 1 - Unfiltered "Bots with no category"
    list.append(("Crap","Rammer",{'nose':math.pi,'radius':0.1,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5}))
    list.append(("Retaliation","Omni",{'invertible':True,'nose':math.pi*2,'radius':0.2,'topspeed':100,'throttle':130,'turn':60,'turnspeed':3.5,'weapons':(10,11,12,13,14,15,16,17,18,19)}))
    list.append(("Inflatable Snowman","Spinner",{'nose':math.pi*2.25,'range':500,'radius':1,'topspeed':3,'throttle':130,'turn':60,'turnspeed':5,'weapons':(27,28,29,30,35,36,37,38,39,40,41,42,43,44,45,46,47,48,53,54)}))
    list.append(("Robot X","Rammer",{'invertible':True,'nose':math.pi,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':2,'AimError':0.1}))
    list.append(("Beta","Judge",{'beta':-64000,'MotorID':1,'StartAngle':-math.pi*0.6,'reload':5,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':2.5,'weapons':(39,)}))
    list.append(("The Judge","Judge",{'MotorID':45,'StartAngle':-math.pi/2,'reload':8,'tactic':"Charge",'SightRange':2,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':2.5,'weapons':(46,)}))

    # 2 - Team Thunder "Your loss will be shocking!"
    list.append(("Refractor","Rammer",{'invertible':True,'nose':math.pi*2,'radius':0.1,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5}))
    list.append(("Tyranny","Omni",{'invertible':True,'nose':math.pi*2,'radius':.1,'range':99,'topspeed':100,'throttle':130,'turn':60,'turnspeed':3,'weapons':(3,4,5,6)}))
    list.append(("Enterprise","Poker",{'invertible':True,'nose':math.pi*2,'range':99,'radius':0.1,'topspeed':100,'throttle':130,'turn':30,'turnspeed':3,'weapons':(22,23,24,25)}))
    list.append(("Bob","EternalFlame",{'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':3,'weapons':(23,)}))
    list.append(("Billy-Bot","Omni",{'invertible':True,'range':50,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':1.5,'weapons':(15,16,24)}))
    list.append(("Alcoholic Stepfather","AlcoholicStepfather",{'invertible':True,'delta':0.5,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':1.5,'weapons':(40,41,43)}))

    # 3 - Rainbow Kittens "The dead bot goes meOW!"
    list.append(("Chaos IV","Omni",{'nose':math.pi*2,'range':99,'radius':0.1,'range':99,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2,'weapons':(4,5)}))
    list.append(("Phoenix","Flipper",{'nose':math.pi*2,'radius':0.1,'topspeed':100,'throttle':130,'turn':60,'turnspeed':3.5,'weapons':(9,10)}))
    list.append(("Primed","Flipper",{'nose':math.pi*2,'range':99,'radius':0.1,'topspeed':100,'throttle':130,'turn':60,'turnspeed':1,'weapons':(13,14,15,16)}))
    list.append(("Moros","Omni",{'nose':math.pi,'MotorID':9,'JamTime':3,'radius':1,'range':99,'topspeed':100,'throttle':100,'turn':100,'turnspeed':2,'weapons':(17,)}))
    list.append(("BioHazard","Flipper2",{'EnemyMoveRadius':0.5,'SrimechInterval':3,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':2.5,'weapons':(33,)}))
    list.append(("Ronin","Omni",{'nose':math.pi,'invertible':True,'radius':1,'range':99,'topspeed':100,'throttle':100,'turn':100,'turnspeed':1,'weapons':(16,)}))

    # 4 - Ice3 "chilling peril"
    list.append(("Rebel 7","Omni",{'invertible':True,'nose':math.pi*2,'radius':0.1,'range':99,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5,'weapons':(19,)}))
    list.append(("HellRaiser","Pusher",{'nose':math.pi*2,'radius':0.1,'range':99,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2}))
    list.append(("Vortex CF","Omni",{'invertible':True,'nose':math.pi*2,'radius':0.1,'range':99,'topspeed':150,'throttle':130,'turn':60,'turnspeed':4,'weapons':(29,41,42)}))
    list.append(("Cleprechaun","Omni",{'nose':math.pi,'radius':1,'range':99,'topspeed':5,'throttle':100,'turn':100,'turnspeed':1.5,'weapons':(17,)}))
    list.append(("El Diablo","Omni",{'invertible':True,'nose':math.pi,'range':99,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':2,'weapons':(6,7,16,17)}))
    list.append(("Shrederator","Omni",{'MotorID':1,'JamTime':999,'nose':math.pi*1.6,'radius':1,'range':99,'topspeed':100,'throttle':100,'turn':100,'turnspeed':1.5,'weapons':(15,)}))

    # 5 - T? "???"
    list.append(("Catastrophy","Omni",{'invertible':True,'nose':math.pi*2,'radius':0.1,'range':99,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5,'weapons':(12,)}))
    list.append(("Exposed","Poker",{'invertible':True,'nose':math.pi*2,'radius':0.1,'topspeed':100,'throttle':130,'turn':130,'turnspeed':5,'weapons':(12,17)}))
    list.append(("Red Flag","Flipper",{'nose':math.pi*2,'radius':0.1,'topspeed':150,'throttle':130,'turn':60,'turnspeed':2,'weapons':(9,10,11,12)}))
    list.append(("Ziggo","Omni",{'MotorID':7,'JamTime':999,'nose':math.pi,'radius':1,'range':99,'topspeed':100,'throttle':100,'turn':100,'turnspeed':2,'weapons':(11,)}))
    list.append(("Potter's Wheel","Omni",{'invertible':True,'nose':math.pi,'range':99,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':1,'weapons':(5,)}))
    list.append(("OverKill","Judge",{'reload':4,'StartAngle':math.pi/2,'MotorID':6,'invertible':True,'nose':math.pi,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':3.5,'weapons':(13,)}))

    # 6 - CAUTION: RADIATION ZONE
    list.append(("Avenger","Rammer",{'nose':math.pi,'radius':0.1,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5}))
    list.append(("Absolute 0","Flipper2",{'nose':math.pi*2,'range':99,'radius':0.1,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5,'weapons':(5,)}))
    list.append(("Prone","Omni",{'invertible':True,'nose':math.pi*2,'radius':0.1,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2,'weapons':(39,42)}))
    list.append(("Whirl Wep","SwitchDirRam",{'invertible':True,'ThresholdSpeed':0.02,'BackUpTime':4,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':2.5,'weapons':(12,),'sweapons':(20,)}))
    list.append(("Slap Happy","FBS_2",{'fbs_range':8,'chase_time':15,'invertible':True,'nose':math.pi,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':1,'weapons':(2,10)}))
    list.append(("Panic Attack","Omni",{'nose':math.pi,'radius':1,'topspeed':6,'throttle':100,'turn':100,'turnspeed':1.5,'weapons':(7,)}))

    # 7 - Team Loud Music
    list.append(("Reactor","Omni",{'nose':math.pi*2,'radius':0.1,'range':99,'topspeed':100,'throttle':130,'turn':60,'turnspeed':3.5,'weapons':(14,15,16)}))
    list.append(("Rex","Omni",{'nose':math.pi*2,'radius':0.1,'topspeed':15,'throttle':130,'turn':60,'turnspeed':2,'weapons':(11,12,13)}))
    list.append(("Bombad","Pusher",{'invertible':True,'radius':0.1,'topspeed':150,'throttle':130,'turn':60,'turnspeed':2}))
    list.append(("Shish-Kabot","Omni",{'tactic':"Charge",'invertible':True,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':2.5,'weapons':(42,)}))
    list.append(("Vlad the Impaler","Omni",{'tactic':"Charge",'ThresholdSpeed':0.02,'reload':16,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':2.5,'weapons':(8,10)}))
    list.append(("Vladiator","Omni",{'nose':math.pi,'tactic':"Ram",'ThresholdSpeed':0.5,'invertible':True,'AimError':0.2,'reload':16,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':2.5,'weapons':(25,)}))

    # 8 - Hidden Robotics
    list.append(("Learn2fly","Flipper",{'nose':math.pi*2,'radius':0.1,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5,'weapons':(6,13)}))
    list.append(("Rip-up","Flipper",{'nose':math.pi*2,'radius':0.1,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5,'weapons':(18,19,20,21)}))
    list.append(("War and Peace","Omni",{'invertible':True,'nose':math.pi*2,'radius':0.1,'range':500,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5,'weapons':(29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54)}))
    list.append(("Backlash","DirectionalSpinner",{'range':99,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':1.5,'weapons':(11,)}))
    list.append(("Heavy Metal Noise","DirectionalSpinner",{'invertible':True,'range':99,'radius':1,'topspeed':100,'throttle':100,'turn':30,'turnspeed':2,'weapons':(16,17,18,19)}))
    list.append(("Nightmare","DirectionalSpinner",{'radius':1,'range':99,'topspeed':100,'throttle':100,'turn':100,'turnspeed':1,'weapons':(19,22,23)}))

    # 9 - LifeRA2
    list.append(("Don't Boter","Omni",{'nose':math.pi*2,'radius':0.1,'range':99,'topspeed':100,'throttle':130,'turn':25,'turnspeed':3,'weapons':(16,)}))
    list.append(("Haywire","Spinner",{'nose':math.pi*1.5,'radius':0.3,'range':500,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5,'weapons':(10,11,12)}))
    list.append(("General Annoyance","Omni",{'radius':0.1,'range':99,'topspeed':100,'throttle':130,'turn':60,'turnspeed':3,'weapons':(7,8,34,35,37,38)}))
    list.append(("YU812","Omni",{'MotorID':1,'radius':1,'range':99,'topspeed':100,'throttle':100,'turn':100,'turnspeed':2.5,'weapons':(16,17,18)}))
    list.append(("MechaVore","EcoOmni",{'range':99,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':3.5,'weapons':(15,)}))
    list.append(("Minion","SwitchDirRam",{'nose':math.pi,'range':99,'ThresholdSpeed':0.02,'BackUpTime':4,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':2.5,'weapons':(42,),'sweapons':(10,)}))

    # 10 - Breaking Dawn Robotics
    list.append(("Revolver","Spinner",{'nose':math.pi,'range':99,'radius':0.5,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5,'weapons':(9,10,11)}))
    list.append(("Rigged","Flipper",{'nose':math.pi*2,'radius':0.1,'topspeed':100,'throttle':130,'turn':30,'turnspeed':2,'weapons':(25,)}))
    list.append(("Crash Zone","Poker",{'invertible':True,'nose':math.pi*2,'radius':0.1,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5,'weapons':(18,19,20,21)}))
    list.append(("Hunter","TopPusher",{'invertible':True,'tactic':"Charge",'ThresholdSpeed':0.02,'BackUpTime':4,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':2.5}))
    list.append(("Complete Control","Flipper2",{'UseSrimech':1,'EnemyMoveRadius':0.5,'nose':math.pi,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':2.5,'weapons':(14,)}))
    list.append(("Tazbot","LaserGuidedTH",{'nose':math.pi,'radius':1,'servorange':4,'servonose':1,'delta':0.75,'servospeed':100,'topspeed':100,'mayFire':True,'throttle':100,'turn':100,'turnspeed':1.5,'weapons':(24,)}))

    # 11 - Team......The Button
    list.append(("Avenger","Pusher",{'invertible':True,'nose':math.pi*2,'radius':0.1,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5}))
    list.append(("Lopsided!","Pusher",{'invertible':True,'nose':math.pi*2,'radius':0.2,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5}))
    list.append(("Hacker","Pusher",{'invertible':True,'nose':math.pi*2,'radius':0.2,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5}))
    list.append(("Apollyon","TopPusher",{'invertible':True,'tactic':"Charge",'ThresholdSpeed':0.02,'BackUpTime':4,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':2.5}))
    list.append(("That Darn Dustpan!","Judge",{'MotorID':13,'StartAngle':math.pi/2,'Tolerance':math.pi/2,'reload':32,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':2.5,'weapons':(18,)}))
    list.append(("The KillDozer","Rammer",{'invertible':True,'nose':math.pi,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':1}))

    # 12 - The Breaking Point
    list.append(("Troll","DirectionalSpinner",{'invertible':True,'nose':math.pi*2,'radius':0.2,'range':500,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5,'weapons':(5,6,7,8)}))
    list.append(("Hypnotizer","DirectionalSpinner",{'invertible':True,'nose':math.pi*2,'range':500,'radius':0.4,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5,'weapons':(8,9,10,11)}))
    list.append(("Dread II","Omni",{'nose':math.pi*2,'range':99,'radius':0.1,'topspeed':100,'throttle':130,'turn':30,'turnspeed':1.5,'weapons':(56,57,58,59,60,61)}))
    list.append(("Whack!","Frenzy",{'radius':1,'topspeed':4,'throttle':100,'turn':100,'turnspeed':2,'weapons':(11,)}))
    list.append(("Hworf","Omni",{'invertible':True,'range':99,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':1,'weapons':(5,7)}))
    list.append(("frenZy","Judge",{'MotorID':5,'StartAngle':math.pi*0.6,'nose':math.pi/2,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':3.5,'weapons':(7,8)}))

    # 13 - >
    list.append(("Raider","Poker",{'invertible':True,'nose':math.pi*2,'range':99,'radius':0.1,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5,'weapons':(10,11,12,13)}))
    list.append(("RP1","Spinner",{'nose':math.pi*2,'radius':0.5,'range':500,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5,'weapons':(18,19,20,21,26,27)}))
    list.append(("EPIX","Omni",{'nose':math.pi*2,'radius':0.1,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5,'weapons':(31,)}))
    list.append(("Vertigo","VertSpinner",{'radius':1,'range':99,'topspeed':100,'throttle':100,'turn':100,'turnspeed':3,'weapons':(22,23),'sweapons':(0,)}))
    list.append(("Tornado Mer","Omni",{'MotorID':1,'nose':math.pi/2.5,'range':99,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':2.5,'weapons':(6,7,8)}))
    list.append(("Tranquilizante","Poker",{'invertible':True,'nose':math.pi*2,'range':99,'radius':0.1,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5,'weapons':(10,11,12,13)}))

    # 14 - The Scrappers "We scrap junk for a living, so your bots won't be a problem at all."
    list.append(("Android","Poker",{'invertible':True,'nose':math.pi*2,'range':99,'radius':0.1,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5,'weapons':(10,11,12,13)}))
    list.append(("Iceneige 2","Spinner",{'nose':math.pi*2,'radius':0.5,'range':500,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5,'weapons':(18,19,20,21,26,27)}))
    list.append(("Genocide III","Omni",{'nose':math.pi*2,'radius':0.1,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5,'weapons':(31,)}))
    list.append(("Flip Test Dummy","VertSpinner",{'radius':1,'range':99,'topspeed':100,'throttle':100,'turn':100,'turnspeed':3,'weapons':(22,23),'sweapons':(0,)}))
    list.append(("The Stuff of Champions","Omni",{'MotorID':1,'nose':math.pi/2.5,'range':99,'radius':1,'topspeed':100,'throttle':100,'turn':100,'turnspeed':2.5,'weapons':(6,7,8)}))
    list.append(("Wrecktangle 2","Poker",{'invertible':True,'nose':math.pi*2,'range':99,'radius':0.1,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5,'weapons':(10,11,12,13)}))

   # 15 - Robot Arena Reincarnated
    list.append(("Rancid","Omni",{'invertible':True,'nose':math.pi*2,'radius':0.1,'range':500,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5,'weapons':(12,20,22,36,37,40)}))
    list.append(("Drone VII","Topknot",{'invertible':False,'whip':"around",'radius':0.1,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5,'weapons':(29,30,31,32,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69)}))
    list.append(("Proid","Poker",{'nose':math.pi,'range':99,'radius':0.1,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2,'weapons':(35,36,37)}))
    list.append(("Road Block","Poker",{'nose':math.pi*2,'range':99,'radius':0.1,'topspeed':100,'throttle':130,'turn':60,'turnspeed':1.5,'weapons':(20,23,29)}))
    list.append(("Agitator","Omni",{'nose':math.pi,'radius':0,'range':50,'topspeed':100,'throttle':130,'turn':60,'turnspeed':1.5,'weapons':(39,40,42,43,47,48)}))
    list.append(("Traction","Omni",{'nose':math.pi*2,'radius':0.1,'topspeed':100,'throttle':130,'turn':130,'turnspeed':2.5,'weapons':(23,24,25)}))

    # 16 - Arthrobotics
    list.append(("AW-Twister","Spinner",{'nose':math.pi*2,'range':15,'radius':0.4,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5,'weapons':(2,)}))
    list.append(("AW-Buzz Saw","Omni",{'nose':math.pi*2,'radius':0.1,'range':15,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5,'weapons':(17,)}))
    list.append(("BW-Odd Bug","Spinner",{'nose':math.pi*2,'range':30,'radius':0.4,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5,'weapons':(6,9,10,11,12)}))
    list.append(("BW-Treason","Omni",{'invertible':True,'nose':math.pi*2,'radius':0.1,'range':30,'topspeed':100,'throttle':130,'turn':60,'turnspeed':3,'weapons':(12,13,14,15)}))
    list.append(("BW-Breakaway","Flipper",{'nose':math.pi*2,'range':99,'radius':0.1,'topspeed':100,'throttle':130,'turn':60,'turnspeed':4.5,'weapons':(10,)}))
    list.append(("Pain II","Omni",{'nose':math.pi,'radius':1,'topspeed':6,'throttle':100,'turn':100,'turnspeed':1.5,'weapons':(7,)}))
   # 17 - miscellanious
    list.append(("AI","Omni",{'nose':math.pi*2,'radius':0.1,'range':15,'topspeed':100,'throttle':130,'turn':60,'turnspeed':2.5,'weapons':(17,)}))